com.fasterxml.jackson.core

## Class JsonGenerator

- java.lang.Object
- - com.fasterxml.jackson.core.JsonGenerator

All Implemented Interfaces:
  Versioned, Closeable, Flushable, AutoCloseable

Direct Known Subclasses:
  GeneratorBase, JsonGeneratorDelegate

    public abstract class JsonGenerator
    extends Object
    implements Closeable, Flushable, Versioned

Base class that defines public API for writing JSON content. Instances are created using factory methods of a `JsonFactory` instance.

Author:
  Tatu Saloranta

### Nested Class Summary

Nested Classes
`static class` `JsonGenerator.Feature` Enumeration that defines all togglable features for generators.

### Field Summary

Fields
`protected PrettyPrinter` `_cfgPrettyPrinter` Object that handles pretty-printing (usually additional white space to make results more human-readable) during output.

### Constructor Summary

Constructors
`protected` `JsonGenerator()`

### Method Summary

Methods
`protected void` `_reportError(String msg)` Helper method used for constructing and throwing `JsonGenerationException` with given base message.
`protected void` `_reportUnsupportedOperation()`
`protected void` `_throwInternal()`
`protected void` `_writeSimpleObject(Object value)` Helper method to try to call appropriate write method for given untyped Object.
`boolean` `canOmitFields()` Introspection method to call to check whether it is ok to omit writing of Object fields or not.
`boolean` `canUseSchema(FormatSchema schema)` Method that can be used to verify that given schema can be used with this generator (using `setSchema(com.fasterxml.jackson.core.FormatSchema)`).
`boolean` `canWriteBinaryNatively()` Introspection method that may be called to see if the underlying data format supports "native" binary data; that is, an efficient output of binary content without encoding.
`boolean` `canWriteFormattedNumbers()`
`boolean` `canWriteObjectId()` Introspection method that may be called to see if the underlying data format supports some kind of Object Ids natively (many do not; for example, JSON doesn't).
`boolean` `canWriteTypeId()` Introspection method that may be called to see if the underlying data format supports some kind of Type Ids natively (many do not; for example, JSON doesn't).
`abstract void` `close()` Method called to close this generator, so that no more content can be written.
`JsonGenerator` `configure(JsonGenerator.Feature f, boolean state)` Method for enabling or disabling specified feature: check `JsonGenerator.Feature` for list of available features.
`void` `copyCurrentEvent(JsonParser p)` Method for copying contents of the current event that the given parser instance points to.
`void` `copyCurrentStructure(JsonParser p)` Method for copying contents of the current event and following events that it encloses the given parser instance points to.
`abstract JsonGenerator` `disable(JsonGenerator.Feature f)` Method for disabling specified features (check `JsonGenerator.Feature` for list of features)
`abstract JsonGenerator` `enable(JsonGenerator.Feature f)` Method for enabling specified parser features: check `JsonGenerator.Feature` for list of available features.
`abstract void` `flush()` Method called to flush any buffered content to the underlying target (output stream, writer), and to flush the target itself as well.
`CharacterEscapes` `getCharacterEscapes()` Method for accessing custom escapes factory uses for `JsonGenerator`s it creates.
`abstract ObjectCodec` `getCodec()` Method for accessing the object used for writing Java object as JSON content (using method `writeObject(java.lang.Object)`).
`Object` `getCurrentValue()` Helper method, usually equivalent to: `getOutputContext().getCurrentValue();`
`abstract int` `getFeatureMask()` Bulk access method for getting state of all standard (non-dataformat-specific) `JsonGenerator.Feature`s.
`int` `getFormatFeatures()` Bulk access method for getting state of all `FormatFeature`s, format-specific on/off configuration settings.
`int` `getHighestEscapedChar()` Accessor method for testing what is the highest unescaped character configured for this generator.
`int` `getOutputBuffered()` Method for verifying amount of content that is buffered by generator but not yet flushed to the underlying target (stream, writer), in units (byte, char) that the generator implementation uses for buffering; or -1 if this information is not available.
`abstract JsonStreamContext` `getOutputContext()`
`Object` `getOutputTarget()` Method that can be used to get access to object that is used as target for generated output; this is usually either `OutputStream` or `Writer`, depending on what generator was constructed with.
`PrettyPrinter` `getPrettyPrinter()` Accessor for checking whether this generator has a configured `PrettyPrinter`; returns it if so, null if none configured.
`FormatSchema` `getSchema()` Method for accessing Schema that this parser uses, if any.
`abstract boolean` `isClosed()` Method that can be called to determine whether this generator is closed or not.
`abstract boolean` `isEnabled(JsonGenerator.Feature f)` Method for checking whether given feature is enabled.
`JsonGenerator` `overrideFormatFeatures(int values, int mask)` Bulk set method for (re)setting states of `FormatFeature`s, by specifying values (set / clear) along with a mask, to determine which features to change, if any.
`JsonGenerator` `overrideStdFeatures(int values, int mask)` Bulk set method for (re)setting states of features specified by `mask`.
`JsonGenerator` `setCharacterEscapes(CharacterEscapes esc)` Method for defining custom escapes factory uses for `JsonGenerator`s it creates.
`abstract JsonGenerator` `setCodec(ObjectCodec oc)` Method that can be called to set or reset the object to use for writing Java objects as JsonContent (using method `writeObject(java.lang.Object)`).
`void` `setCurrentValue(Object v)` Helper method, usually equivalent to: `getOutputContext().setCurrentValue(v);`
`abstract JsonGenerator` `setFeatureMask(int values)` Deprecated. Since 2.7, use `overrideStdFeatures(int, int)` instead
`JsonGenerator` `setHighestNonEscapedChar(int charCode)` Method that can be called to request that generator escapes all character codes above specified code point (if positive value); or, to not escape any characters except for ones that must be escaped for the data format (if -1).
`JsonGenerator` `setPrettyPrinter(PrettyPrinter pp)` Method for setting a custom pretty printer, which is usually used to add indentation for improved human readability.
`JsonGenerator` `setRootValueSeparator(SerializableString sep)` Method that allows overriding String used for separating root-level JSON values (default is single space character)
`void` `setSchema(FormatSchema schema)` Method to call to make this generator use specified schema.
`abstract JsonGenerator` `useDefaultPrettyPrinter()` Convenience method for enabling pretty-printing using the default pretty printer (`DefaultPrettyPrinter`).
`abstract Version` `version()` Accessor for finding out version of the bundle that provided this generator instance.
`void` `writeArray(double[] array, int offset, int length)`
`void` `writeArray(int[] array, int offset, int length)`
`void` `writeArray(long[] array, int offset, int length)`
`void` `writeArrayFieldStart(String fieldName)` Convenience method for outputting a field entry ("member") (that will contain a JSON Array value), and the START_ARRAY marker.
`abstract void` `writeBinary(Base64Variant bv, byte[] data, int offset, int len)` Method that will output given chunk of binary data as base64 encoded, as a complete String value (surrounded by double quotes).
`abstract int` `writeBinary(Base64Variant bv, InputStream data, int dataLength)` Method similar to `writeBinary(Base64Variant,byte[],int,int)`, but where input is provided through a stream, allowing for incremental writes without holding the whole input in memory.
`void` `writeBinary(byte[] data)` Similar to `writeBinary(Base64Variant,byte[],int,int)`, but assumes default to using the Jackson default Base64 variant (which is `Base64Variants.MIME_NO_LINEFEEDS`).
`void` `writeBinary(byte[] data, int offset, int len)` Similar to `writeBinary(Base64Variant,byte[],int,int)`, but default to using the Jackson default Base64 variant (which is `Base64Variants.MIME_NO_LINEFEEDS`).
`int` `writeBinary(InputStream data, int dataLength)` Similar to `writeBinary(Base64Variant,InputStream,int)`, but assumes default to using the Jackson default Base64 variant (which is `Base64Variants.MIME_NO_LINEFEEDS`).
`void` `writeBinaryField(String fieldName, byte[] data)` Convenience method for outputting a field entry ("member") that contains specified data in base64-encoded form.
`abstract void` `writeBoolean(boolean state)` Method for outputting literal JSON boolean value (one of Strings 'true' and 'false').
`void` `writeBooleanField(String fieldName, boolean value)` Convenience method for outputting a field entry ("member") that has a boolean value.
`abstract void` `writeEndArray()` Method for writing closing marker of a JSON Array value (character ']'; plus possible white space decoration if pretty-printing is enabled).
`abstract void` `writeEndObject()` Method for writing closing marker of a JSON Object value (character '}'; plus possible white space decoration if pretty-printing is enabled).
`abstract void` `writeFieldName(SerializableString name)` Method similar to `writeFieldName(String)`, main difference being that it may perform better as some of processing (such as quoting of certain characters, or encoding into external encoding if supported by generator) can be done just once and reused for later calls.
`abstract void` `writeFieldName(String name)` Method for writing a field name (JSON String surrounded by double quotes: syntactically identical to a JSON String value), possibly decorated by white space if pretty-printing is enabled.
`abstract void` `writeNull()` Method for outputting literal JSON null value.
`void` `writeNullField(String fieldName)` Convenience method for outputting a field entry ("member") that has JSON literal value null.
`abstract void` `writeNumber(BigDecimal v)` Method for outputting indicate JSON numeric value.
`abstract void` `writeNumber(BigInteger v)` Method for outputting given value as JSON number.
`abstract void` `writeNumber(double v)` Method for outputting indicate JSON numeric value.
`abstract void` `writeNumber(float v)` Method for outputting indicate JSON numeric value.
`abstract void` `writeNumber(int v)` Method for outputting given value as JSON number.
`abstract void` `writeNumber(long v)` Method for outputting given value as JSON number.
`void` `writeNumber(short v)` Method for outputting given value as JSON number.
`abstract void` `writeNumber(String encodedValue)` Write method that can be used for custom numeric types that can not be (easily?) converted to "standard" Java number types.
`void` `writeNumberField(String fieldName, BigDecimal value)` Convenience method for outputting a field entry ("member") that has the specified numeric value.
`void` `writeNumberField(String fieldName, double value)` Convenience method for outputting a field entry ("member") that has the specified numeric value.
`void` `writeNumberField(String fieldName, float value)` Convenience method for outputting a field entry ("member") that has the specified numeric value.
`void` `writeNumberField(String fieldName, int value)` Convenience method for outputting a field entry ("member") that has the specified numeric value.
`void` `writeNumberField(String fieldName, long value)` Convenience method for outputting a field entry ("member") that has the specified numeric value.
`abstract void` `writeObject(Object pojo)` Method for writing given Java object (POJO) as Json.
`void` `writeObjectField(String fieldName, Object pojo)` Convenience method for outputting a field entry ("member") that has contents of specific Java object as its value.
`void` `writeObjectFieldStart(String fieldName)` Convenience method for outputting a field entry ("member") (that will contain a JSON Object value), and the START_OBJECT marker.
`void` `writeObjectId(Object id)` Method that can be called to output so-called native Object Id.
`void` `writeObjectRef(Object id)` Method that can be called to output references to native Object Ids.
`void` `writeOmittedField(String fieldName)` Method called to indicate that a property in this position was skipped.
`abstract void` `writeRaw(char c)` Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such).
`abstract void` `writeRaw(char[] text, int offset, int len)` Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such).
`void` `writeRaw(SerializableString raw)` Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such).
`abstract void` `writeRaw(String text)` Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such).
`abstract void` `writeRaw(String text, int offset, int len)` Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such).
`abstract void` `writeRawUTF8String(byte[] text, int offset, int length)` Method similar to `writeString(String)` but that takes as its input a UTF-8 encoded String that is to be output as-is, without additional escaping (type of which depends on data format; backslashes for JSON).
`abstract void` `writeRawValue(char[] text, int offset, int len)`
`void` `writeRawValue(SerializableString raw)` Method similar to `writeRawValue(String)`, but potentially more efficient as it may be able to use pre-encoded content (similar to `writeRaw(SerializableString)`.
`abstract void` `writeRawValue(String text)` Method that will force generator to copy input text verbatim without any modifications, but assuming it must constitute a single legal JSON value (number, string, boolean, null, Array or List).
`abstract void` `writeRawValue(String text, int offset, int len)`
`abstract void` `writeStartArray()` Method for writing starting marker of a Array value (for JSON this is character '['; plus possible white space decoration if pretty-printing is enabled).
`void` `writeStartArray(int size)` Method for writing start marker of an Array value, similar to `writeStartArray()`, but also specifying how many elements will be written for the array before calling `writeEndArray()`.
`abstract void` `writeStartObject()` Method for writing starting marker of a JSON Object value (character '{'; plus possible white space decoration if pretty-printing is enabled).
`void` `writeStartObject(Object forValue)`
`abstract void` `writeString(char[] text, int offset, int len)` Method for outputting a String value.
`abstract void` `writeString(SerializableString text)` Method similar to `writeString(String)`, but that takes `SerializableString` which can make this potentially more efficient to call as generator may be able to reuse quoted and/or encoded representation.
`abstract void` `writeString(String text)` Method for outputting a String value.
`void` `writeStringField(String fieldName, String value)` Convenience method for outputting a field entry ("member") that has a String value.
`abstract void` `writeTree(TreeNode rootNode)` Method for writing given JSON tree (expressed as a tree where given JsonNode is the root) using this generator.
`void` `writeTypeId(Object id)` Method that can be called to output so-called native Type Id.
`abstract void` `writeUTF8String(byte[] text, int offset, int length)` Method similar to `writeString(String)` but that takes as its input a UTF-8 encoded String which has not been escaped using whatever escaping scheme data format requires (for JSON that is backslash-escaping for control characters and double-quotes; for other formats something else).

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### _cfgPrettyPrinter

    protected PrettyPrinter _cfgPrettyPrinter

Object that handles pretty-printing (usually additional white space to make results more human-readable) during output. If null, no pretty-printing is done.

### Constructor Detail

#### JsonGenerator

    protected JsonGenerator()

### Method Detail

#### setCodec

    public abstract JsonGenerator setCodec(ObjectCodec oc)

Method that can be called to set or reset the object to use for writing Java objects as JsonContent (using method `writeObject(java.lang.Object)`).

Returns:
  Generator itself (this), to allow chaining

#### getCodec

    public abstract ObjectCodec getCodec()

Method for accessing the object used for writing Java object as JSON content (using method `writeObject(java.lang.Object)`).

#### version

    public abstract Version version()

Accessor for finding out version of the bundle that provided this generator instance.

Specified by:
  `version` in interface `Versioned`

#### canWriteFormattedNumbers

    public boolean canWriteFormattedNumbers()

#### writeStartObject

    public void writeStartObject(Object forValue)
                          throws IOException

Throws:
  `IOException`

#### writeArray

    public void writeArray(int[] array,
                  int offset,
                  int length)
                    throws IOException

Throws:
  `IOException`

#### writeArray

    public void writeArray(long[] array,
                  int offset,
                  int length)
                    throws IOException

Throws:
  `IOException`

#### writeArray

    public void writeArray(double[] array,
                  int offset,
                  int length)
                    throws IOException

Throws:
  `IOException`

#### enable

    public abstract JsonGenerator enable(JsonGenerator.Feature f)

Method for enabling specified parser features: check `JsonGenerator.Feature` for list of available features.

Returns:
  Generator itself (this), to allow chaining

#### disable

    public abstract JsonGenerator disable(JsonGenerator.Feature f)

Method for disabling specified features (check `JsonGenerator.Feature` for list of features)

Returns:
  Generator itself (this), to allow chaining

#### configure

    public final JsonGenerator configure(JsonGenerator.Feature f,
                          boolean state)

Method for enabling or disabling specified feature: check `JsonGenerator.Feature` for list of available features.

Returns:
  Generator itself (this), to allow chaining

#### isEnabled

    public abstract boolean isEnabled(JsonGenerator.Feature f)

Method for checking whether given feature is enabled. Check `JsonGenerator.Feature` for list of available features.

#### getFeatureMask

    public abstract int getFeatureMask()

Bulk access method for getting state of all standard (non-dataformat-specific) `JsonGenerator.Feature`s.

Returns:
  Bit mask that defines current states of all standard `JsonGenerator.Feature`s.
Since:
  2.3

#### setFeatureMask

    @Deprecated
    public abstract JsonGenerator setFeatureMask(int values)

Deprecated. Since 2.7, use `overrideStdFeatures(int, int)` instead
Bulk set method for (re)setting states of all standard `JsonGenerator.Feature`s

Parameters:
  `values` - Bitmask that defines which `JsonGenerator.Feature`s are enabled and which disabled
Returns:
  This parser object, to allow chaining of calls
Since:
  2.3

#### overrideStdFeatures

    public JsonGenerator overrideStdFeatures(int values,
                                    int mask)

Bulk set method for (re)setting states of features specified by `mask`. Functionally equivalent to `int oldState = getFeatureMask(); int newState = (oldState & ~mask) | (values & mask); setFeatureMask(newState);` but preferred as this lets caller more efficiently specify actual changes made.

Parameters:
  `values` - Bit mask of set/clear state for features to change
  `mask` - Bit mask of features to change
Since:
  2.6

#### getFormatFeatures

    public int getFormatFeatures()

Bulk access method for getting state of all `FormatFeature`s, format-specific on/off configuration settings.

Returns:
  Bit mask that defines current states of all standard `FormatFeature`s.
Since:
  2.6

#### overrideFormatFeatures

    public JsonGenerator overrideFormatFeatures(int values,
                                       int mask)

Bulk set method for (re)setting states of `FormatFeature`s, by specifying values (set / clear) along with a mask, to determine which features to change, if any.

Default implementation will simply throw an exception to indicate that the generator implementation does not support any `FormatFeature`s.

Parameters:
  `values` - Bit mask of set/clear state for features to change
  `mask` - Bit mask of features to change
Since:
  2.6

#### setSchema

    public void setSchema(FormatSchema schema)

Method to call to make this generator use specified schema. Method must be called before generating any content, right after instance has been created. Note that not all generators support schemas; and those that do usually only accept specific types of schemas: ones defined for data format this generator produces.

If generator does not support specified schema, `UnsupportedOperationException` is thrown.

Parameters:
  `schema` - Schema to use
Throws:
  `UnsupportedOperationException` - if generator does not support schema

#### getSchema

    public FormatSchema getSchema()

Method for accessing Schema that this parser uses, if any. Default implementation returns null.

Since:
  2.1

#### setPrettyPrinter

    public JsonGenerator setPrettyPrinter(PrettyPrinter pp)

Method for setting a custom pretty printer, which is usually used to add indentation for improved human readability. By default, generator does not do pretty printing.

To use the default pretty printer that comes with core Jackson distribution, call `useDefaultPrettyPrinter()` instead.

Returns:
  Generator itself (this), to allow chaining

#### getPrettyPrinter

    public PrettyPrinter getPrettyPrinter()

Accessor for checking whether this generator has a configured `PrettyPrinter`; returns it if so, null if none configured.

Since:
  2.1

#### useDefaultPrettyPrinter

    public abstract JsonGenerator useDefaultPrettyPrinter()

Convenience method for enabling pretty-printing using the default pretty printer (`DefaultPrettyPrinter`).

Returns:
  Generator itself (this), to allow chaining

#### setHighestNonEscapedChar

    public JsonGenerator setHighestNonEscapedChar(int charCode)

Method that can be called to request that generator escapes all character codes above specified code point (if positive value); or, to not escape any characters except for ones that must be escaped for the data format (if -1). To force escaping of all non-ASCII characters, for example, this method would be called with value of 127.

Note that generators are NOT required to support setting of value higher than 127, because there are other ways to affect quoting (or lack thereof) of character codes between 0 and 127. Not all generators support concept of escaping, either; if so, calling this method will have no effect.

Default implementation does nothing; sub-classes need to redefine it according to rules of supported data format.

Parameters:
  `charCode` - Either -1 to indicate that no additional escaping is to be done; or highest code point not to escape (meaning higher ones will be), if positive value.

#### getHighestEscapedChar

    public int getHighestEscapedChar()

Accessor method for testing what is the highest unescaped character configured for this generator. This may be either positive value (when escaping configuration has been set and is in effect), or 0 to indicate that no additional escaping is in effect. Some generators may not support additional escaping: for example, generators for binary formats that do not use escaping should simply return 0.

Returns:
  Currently active limitation for highest non-escaped character, if defined; or -1 to indicate no additional escaping is performed.

#### getCharacterEscapes

    public CharacterEscapes getCharacterEscapes()

Method for accessing custom escapes factory uses for `JsonGenerator`s it creates.

#### setCharacterEscapes

    public JsonGenerator setCharacterEscapes(CharacterEscapes esc)

Method for defining custom escapes factory uses for `JsonGenerator`s it creates.

Default implementation does nothing and simply returns this instance.

#### setRootValueSeparator

    public JsonGenerator setRootValueSeparator(SerializableString sep)

Method that allows overriding String used for separating root-level JSON values (default is single space character)

Default implementation throws `UnsupportedOperationException`.

Parameters:
  `sep` - Separator to use, if any; null means that no separator is automatically added
Since:
  2.1

#### getOutputTarget

    public Object getOutputTarget()

Method that can be used to get access to object that is used as target for generated output; this is usually either `OutputStream` or `Writer`, depending on what generator was constructed with. Note that returned value may be null in some cases; including case where implementation does not want to exposed raw source to caller. In cases where output has been decorated, object returned here is the decorated version; this allows some level of interaction between users of generator and decorator object.

In general use of this accessor should be considered as "last effort", i.e. only used if no other mechanism is applicable.

#### getOutputBuffered

    public int getOutputBuffered()

Method for verifying amount of content that is buffered by generator but not yet flushed to the underlying target (stream, writer), in units (byte, char) that the generator implementation uses for buffering; or -1 if this information is not available. Unit used is often the same as the unit of underlying target (that is, `byte` for `OutputStream`, `char` for `Writer`), but may differ if buffering is done before encoding. Default JSON-backed implementations do use matching units.

Note: non-JSON implementations will be retrofitted for 2.6 and beyond; please report if you see -1 (missing override)

Returns:
  Amount of content buffered in internal units, if amount known and accessible; -1 if not accessible.
Since:
  2.6

#### getCurrentValue

    public Object getCurrentValue()

Helper method, usually equivalent to: `getOutputContext().getCurrentValue();`

Note that "current value" is NOT populated (or used) by Streaming parser; it is only used by higher-level data-binding functionality. The reason it is included here is that it can be stored and accessed hierarchically, and gets passed through data-binding.

Since:
  2.5

#### setCurrentValue

    public void setCurrentValue(Object v)

Helper method, usually equivalent to: `getOutputContext().setCurrentValue(v);`

Since:
  2.5

#### canUseSchema

    public boolean canUseSchema(FormatSchema schema)

Method that can be used to verify that given schema can be used with this generator (using `setSchema(com.fasterxml.jackson.core.FormatSchema)`).

Parameters:
  `schema` - Schema to check
Returns:
  True if this generator can use given schema; false if not

#### canWriteObjectId

    public boolean canWriteObjectId()

Introspection method that may be called to see if the underlying data format supports some kind of Object Ids natively (many do not; for example, JSON doesn't). This method must be called prior to calling `writeObjectId(java.lang.Object)` or `writeObjectRef(java.lang.Object)`.

Default implementation returns false; overridden by data formats that do support native Object Ids. Caller is expected to either use a non-native notation (explicit property or such), or fail, in case it can not use native object ids.

Since:
  2.3

#### canWriteTypeId

    public boolean canWriteTypeId()

Introspection method that may be called to see if the underlying data format supports some kind of Type Ids natively (many do not; for example, JSON doesn't). This method must be called prior to calling `writeTypeId(java.lang.Object)`.

Default implementation returns false; overridden by data formats that do support native Type Ids. Caller is expected to either use a non-native notation (explicit property or such), or fail, in case it can not use native type ids.

Since:
  2.3

#### canWriteBinaryNatively

    public boolean canWriteBinaryNatively()

Introspection method that may be called to see if the underlying data format supports "native" binary data; that is, an efficient output of binary content without encoding.

Default implementation returns false; overridden by data formats that do support native binary content.

Since:
  2.3

#### canOmitFields

    public boolean canOmitFields()

Introspection method to call to check whether it is ok to omit writing of Object fields or not. Most formats do allow omission, but certain positional formats (such as CSV) require output of placeholders, even if no real values are to be emitted.

Since:
  2.3

#### writeStartArray

    public abstract void writeStartArray()
                                  throws IOException

Method for writing starting marker of a Array value (for JSON this is character '['; plus possible white space decoration if pretty-printing is enabled).

Array values can be written in any context where values are allowed: meaning everywhere except for when a field name is expected.

Throws:
  `IOException`

#### writeStartArray

    public void writeStartArray(int size)
                         throws IOException

Method for writing start marker of an Array value, similar to `writeStartArray()`, but also specifying how many elements will be written for the array before calling `writeEndArray()`.

Default implementation simply calls `writeStartArray()`.

Parameters:
  `size` - Number of elements this array will have: actual number of values written (before matching call to `writeEndArray()` MUST match; generator MAY verify this is the case.
Throws:
  `IOException`
Since:
  2.4

#### writeEndArray

    public abstract void writeEndArray()
                                throws IOException

Method for writing closing marker of a JSON Array value (character ']'; plus possible white space decoration if pretty-printing is enabled).

Marker can be written if the innermost structured type is Array.

Throws:
  `IOException`

#### writeStartObject

    public abstract void writeStartObject()
                                   throws IOException

Method for writing starting marker of a JSON Object value (character '{'; plus possible white space decoration if pretty-printing is enabled).

Object values can be written in any context where values are allowed: meaning everywhere except for when a field name is expected.

Throws:
  `IOException`

#### writeEndObject

    public abstract void writeEndObject()
                                 throws IOException

Method for writing closing marker of a JSON Object value (character '}'; plus possible white space decoration if pretty-printing is enabled).

Marker can be written if the innermost structured type is Object, and the last written event was either a complete value, or START-OBJECT marker (see JSON specification for more details).

Throws:
  `IOException`

#### writeFieldName

    public abstract void writeFieldName(String name)
                                 throws IOException

Method for writing a field name (JSON String surrounded by double quotes: syntactically identical to a JSON String value), possibly decorated by white space if pretty-printing is enabled.

Field names can only be written in Object context (check out JSON specification for details), when field name is expected (field names alternate with values).

Throws:
  `IOException`

#### writeFieldName

    public abstract void writeFieldName(SerializableString name)
                                 throws IOException

Method similar to `writeFieldName(String)`, main difference being that it may perform better as some of processing (such as quoting of certain characters, or encoding into external encoding if supported by generator) can be done just once and reused for later calls.

Default implementation simple uses unprocessed name container in serialized String; implementations are strongly encouraged to make use of more efficient methods argument object has.

Throws:
  `IOException`

#### writeString

    public abstract void writeString(String text)
                              throws IOException

Method for outputting a String value. Depending on context this means either array element, (object) field value or a stand alone String; but in all cases, String will be surrounded in double quotes, and contents will be properly escaped as required by JSON specification.

Throws:
  `IOException`

#### writeString

    public abstract void writeString(char[] text,
                   int offset,
                   int len)
                              throws IOException

Method for outputting a String value. Depending on context this means either array element, (object) field value or a stand alone String; but in all cases, String will be surrounded in double quotes, and contents will be properly escaped as required by JSON specification.

Throws:
  `IOException`

#### writeString

    public abstract void writeString(SerializableString text)
                              throws IOException

Method similar to `writeString(String)`, but that takes `SerializableString` which can make this potentially more efficient to call as generator may be able to reuse quoted and/or encoded representation.

Default implementation just calls `writeString(String)`; sub-classes should override it with more efficient implementation if possible.

Throws:
  `IOException`

#### writeRawUTF8String

    public abstract void writeRawUTF8String(byte[] text,
                          int offset,
                          int length)
                                     throws IOException

Method similar to `writeString(String)` but that takes as its input a UTF-8 encoded String that is to be output as-is, without additional escaping (type of which depends on data format; backslashes for JSON). However, quoting that data format requires (like double-quotes for JSON) will be added around the value if and as necessary.

Note that some backends may choose not to support this method: for example, if underlying destination is a `Writer` using this method would require UTF-8 decoding. If so, implementation may instead choose to throw a `UnsupportedOperationException` due to ineffectiveness of having to decode input.

Throws:
  `IOException`

#### writeUTF8String

    public abstract void writeUTF8String(byte[] text,
                       int offset,
                       int length)
                                  throws IOException

Method similar to `writeString(String)` but that takes as its input a UTF-8 encoded String which has not been escaped using whatever escaping scheme data format requires (for JSON that is backslash-escaping for control characters and double-quotes; for other formats something else). This means that textual JSON backends need to check if value needs JSON escaping, but otherwise can just be copied as is to output. Also, quoting that data format requires (like double-quotes for JSON) will be added around the value if and as necessary.

Note that some backends may choose not to support this method: for example, if underlying destination is a `Writer` using this method would require UTF-8 decoding. In this case generator implementation may instead choose to throw a `UnsupportedOperationException` due to ineffectiveness of having to decode input.

Throws:
  `IOException`

#### writeRaw

    public abstract void writeRaw(String text)
                           throws IOException

Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such). If such separators are desired, use `writeRawValue(String)` instead.

Note that not all generator implementations necessarily support such by-pass methods: those that do not will throw `UnsupportedOperationException`.

Throws:
  `IOException`

#### writeRaw

    public abstract void writeRaw(String text,
                int offset,
                int len)
                           throws IOException

Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such). If such separators are desired, use `writeRawValue(String)` instead.

Note that not all generator implementations necessarily support such by-pass methods: those that do not will throw `UnsupportedOperationException`.

Throws:
  `IOException`

#### writeRaw

    public abstract void writeRaw(char[] text,
                int offset,
                int len)
                           throws IOException

Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such). If such separators are desired, use `writeRawValue(String)` instead.

Note that not all generator implementations necessarily support such by-pass methods: those that do not will throw `UnsupportedOperationException`.

Throws:
  `IOException`

#### writeRaw

    public abstract void writeRaw(char c)
                           throws IOException

Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such). If such separators are desired, use `writeRawValue(String)` instead.

Note that not all generator implementations necessarily support such by-pass methods: those that do not will throw `UnsupportedOperationException`.

Throws:
  `IOException`

#### writeRaw

    public void writeRaw(SerializableString raw)
                  throws IOException

Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such). If such separators are desired, use `writeRawValue(String)` instead.

Note that not all generator implementations necessarily support such by-pass methods: those that do not will throw `UnsupportedOperationException`.

The default implementation delegates to `writeRaw(String)`; other backends that support raw inclusion of text are encouraged to implement it in more efficient manner (especially if they use UTF-8 encoding).

Throws:
  `IOException`
Since:
  2.1

#### writeRawValue

    public abstract void writeRawValue(String text)
                                throws IOException

Method that will force generator to copy input text verbatim without any modifications, but assuming it must constitute a single legal JSON value (number, string, boolean, null, Array or List). Assuming this, proper separators are added if and as needed (comma or colon), and generator state updated to reflect this.

Throws:
  `IOException`

#### writeRawValue

    public abstract void writeRawValue(String text,
                     int offset,
                     int len)
                                throws IOException

Throws:
  `IOException`

#### writeRawValue

    public abstract void writeRawValue(char[] text,
                     int offset,
                     int len)
                                throws IOException

Throws:
  `IOException`

#### writeRawValue

    public void writeRawValue(SerializableString raw)
                       throws IOException

Method similar to `writeRawValue(String)`, but potentially more efficient as it may be able to use pre-encoded content (similar to `writeRaw(SerializableString)`.

Throws:
  `IOException`
Since:
  2.5

#### writeBinary

    public abstract void writeBinary(Base64Variant bv,
                   byte[] data,
                   int offset,
                   int len)
                              throws IOException

Method that will output given chunk of binary data as base64 encoded, as a complete String value (surrounded by double quotes). This method defaults

Note: because JSON Strings can not contain unescaped linefeeds, if linefeeds are included (as per last argument), they must be escaped. This adds overhead for decoding without improving readability. Alternatively if linefeeds are not included, resulting String value may violate the requirement of base64 RFC which mandates line-length of 76 characters and use of linefeeds. However, all `JsonParser` implementations are required to accept such "long line base64"; as do typical production-level base64 decoders.

Parameters:
  `bv` - Base64 variant to use: defines details such as whether padding is used (and if so, using which character); what is the maximum line length before adding linefeed, and also the underlying alphabet to use.
Throws:
  `IOException`

#### writeBinary

    public void writeBinary(byte[] data,
                   int offset,
                   int len)
                     throws IOException

Similar to `writeBinary(Base64Variant,byte[],int,int)`, but default to using the Jackson default Base64 variant (which is `Base64Variants.MIME_NO_LINEFEEDS`).

Throws:
  `IOException`

#### writeBinary

    public void writeBinary(byte[] data)
                     throws IOException

Similar to `writeBinary(Base64Variant,byte[],int,int)`, but assumes default to using the Jackson default Base64 variant (which is `Base64Variants.MIME_NO_LINEFEEDS`). Also assumes that whole byte array is to be output.

Throws:
  `IOException`

#### writeBinary

    public int writeBinary(InputStream data,
                  int dataLength)
                    throws IOException

Similar to `writeBinary(Base64Variant,InputStream,int)`, but assumes default to using the Jackson default Base64 variant (which is `Base64Variants.MIME_NO_LINEFEEDS`).

Parameters:
  `data` - InputStream to use for reading binary data to write. Will not be closed after successful write operation
  `dataLength` - (optional) number of bytes that will be available; or -1 to be indicate it is not known. Note that implementations need not support cases where length is not known in advance; this depends on underlying data format: JSON output does NOT require length, other formats may
Throws:
  `IOException`

#### writeBinary

    public abstract int writeBinary(Base64Variant bv,
                  InputStream data,
                  int dataLength)
                             throws IOException

Method similar to `writeBinary(Base64Variant,byte[],int,int)`, but where input is provided through a stream, allowing for incremental writes without holding the whole input in memory.

Parameters:
  `bv` - Base64 variant to use
  `data` - InputStream to use for reading binary data to write. Will not be closed after successful write operation
  `dataLength` - (optional) number of bytes that will be available; or -1 to be indicate it is not known. If a positive length is given, `data` MUST provide at least that many bytes: if not, an exception will be thrown. Note that implementations need not support cases where length is not known in advance; this depends on underlying data format: JSON output does NOT require length, other formats may.
Returns:
  Number of bytes read from `data` and written as binary payload
Throws:
  `IOException`
Since:
  2.1

#### writeNumber

    public void writeNumber(short v)
                     throws IOException

Method for outputting given value as JSON number. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.

Parameters:
  `v` - Number value to write
Throws:
  `IOException`
Since:
  2.2

#### writeNumber

    public abstract void writeNumber(int v)
                              throws IOException

Method for outputting given value as JSON number. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.

Parameters:
  `v` - Number value to write
Throws:
  `IOException`

#### writeNumber

    public abstract void writeNumber(long v)
                              throws IOException

Method for outputting given value as JSON number. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.

Parameters:
  `v` - Number value to write
Throws:
  `IOException`

#### writeNumber

    public abstract void writeNumber(BigInteger v)
                              throws IOException

Method for outputting given value as JSON number. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.

Parameters:
  `v` - Number value to write
Throws:
  `IOException`

#### writeNumber

    public abstract void writeNumber(double v)
                              throws IOException

Method for outputting indicate JSON numeric value. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.

Parameters:
  `v` - Number value to write
Throws:
  `IOException`

#### writeNumber

    public abstract void writeNumber(float v)
                              throws IOException

Method for outputting indicate JSON numeric value. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.

Parameters:
  `v` - Number value to write
Throws:
  `IOException`

#### writeNumber

    public abstract void writeNumber(BigDecimal v)
                              throws IOException

Method for outputting indicate JSON numeric value. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.

Parameters:
  `v` - Number value to write
Throws:
  `IOException`

#### writeNumber

    public abstract void writeNumber(String encodedValue)
                              throws IOException

Write method that can be used for custom numeric types that can not be (easily?) converted to "standard" Java number types. Because numbers are not surrounded by double quotes, regular `writeString(java.lang.String)` method can not be used; nor `writeRaw(java.lang.String)` because that does not properly handle value separators needed in Array or Object contexts.

Note: because of lack of type safety, some generator implementations may not be able to implement this method. For example, if a binary JSON format is used, it may require type information for encoding; similarly for generator-wrappers around Java objects or JSON nodes. If implementation does not implement this method, it needs to throw `UnsupportedOperationException`.

Throws:
  `UnsupportedOperationException` - If underlying data format does not support numbers serialized textually AND if generator is not allowed to just output a String instead (Schema-based formats may require actual number, for example)
  `IOException`

#### writeBoolean

    public abstract void writeBoolean(boolean state)
                               throws IOException

Method for outputting literal JSON boolean value (one of Strings 'true' and 'false'). Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.

Throws:
  `IOException`

#### writeNull

    public abstract void writeNull()
                            throws IOException

Method for outputting literal JSON null value. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.

Throws:
  `IOException`

#### writeObjectId

    public void writeObjectId(Object id)
                       throws IOException

Method that can be called to output so-called native Object Id. Note that it may only be called after ensuring this is legal (with `canWriteObjectId()`), as not all data formats have native type id support; and some may only allow them in certain positions or locations. If output is not allowed by the data format in this position, a `JsonGenerationException` will be thrown.

Throws:
  `IOException`
Since:
  2.3

#### writeObjectRef

    public void writeObjectRef(Object id)
                        throws IOException

Method that can be called to output references to native Object Ids. Note that it may only be called after ensuring this is legal (with `canWriteObjectId()`), as not all data formats have native type id support; and some may only allow them in certain positions or locations. If output is not allowed by the data format in this position, a `JsonGenerationException` will be thrown.

Throws:
  `IOException`

#### writeTypeId

    public void writeTypeId(Object id)
                     throws IOException

Method that can be called to output so-called native Type Id. Note that it may only be called after ensuring this is legal (with `canWriteTypeId()`), as not all data formats have native type id support; and some may only allow them in certain positions or locations. If output is not allowed by the data format in this position, a `JsonGenerationException` will be thrown.

Throws:
  `IOException`
Since:
  2.3

#### writeObject

    public abstract void writeObject(Object pojo)
                              throws IOException

Method for writing given Java object (POJO) as Json. Exactly how the object gets written depends on object in question (ad on codec, its configuration); for most beans it will result in JSON Object, but for others JSON Array, or String or numeric value (and for nulls, JSON null literal. NOTE: generator must have its object codec set to non-null value; for generators created by a mapping factory this is the case, for others not.

Throws:
  `IOException`

#### writeTree

    public abstract void writeTree(TreeNode rootNode)
                            throws IOException

Method for writing given JSON tree (expressed as a tree where given JsonNode is the root) using this generator. This will generally just call `writeObject(java.lang.Object)` with given node, but is added for convenience and to make code more explicit in cases where it deals specifically with trees.

Throws:
  `IOException`

#### writeStringField

    public void writeStringField(String fieldName,
                        String value)
                          throws IOException

Convenience method for outputting a field entry ("member") that has a String value. Equivalent to:

      writeFieldName(fieldName);
      writeString(value);

Note: many performance-sensitive implementations override this method

Throws:
  `IOException`

#### writeBooleanField

    public final void writeBooleanField(String fieldName,
                         boolean value)
                                 throws IOException

Convenience method for outputting a field entry ("member") that has a boolean value. Equivalent to:

      writeFieldName(fieldName);
      writeBoolean(value);

Throws:
  `IOException`

#### writeNullField

    public final void writeNullField(String fieldName)
                              throws IOException

Convenience method for outputting a field entry ("member") that has JSON literal value null. Equivalent to:

      writeFieldName(fieldName);
      writeNull();

Throws:
  `IOException`

#### writeNumberField

    public final void writeNumberField(String fieldName,
                        int value)
                                throws IOException

Convenience method for outputting a field entry ("member") that has the specified numeric value. Equivalent to:

      writeFieldName(fieldName);
      writeNumber(value);

Throws:
  `IOException`

#### writeNumberField

    public final void writeNumberField(String fieldName,
                        long value)
                                throws IOException

Convenience method for outputting a field entry ("member") that has the specified numeric value. Equivalent to:

      writeFieldName(fieldName);
      writeNumber(value);

Throws:
  `IOException`

#### writeNumberField

    public final void writeNumberField(String fieldName,
                        double value)
                                throws IOException

Convenience method for outputting a field entry ("member") that has the specified numeric value. Equivalent to:

      writeFieldName(fieldName);
      writeNumber(value);

Throws:
  `IOException`

#### writeNumberField

    public final void writeNumberField(String fieldName,
                        float value)
                                throws IOException

Convenience method for outputting a field entry ("member") that has the specified numeric value. Equivalent to:

      writeFieldName(fieldName);
      writeNumber(value);

Throws:
  `IOException`

#### writeNumberField

    public final void writeNumberField(String fieldName,
                        BigDecimal value)
                                throws IOException

Convenience method for outputting a field entry ("member") that has the specified numeric value. Equivalent to:

      writeFieldName(fieldName);
      writeNumber(value);

Throws:
  `IOException`

#### writeBinaryField

    public final void writeBinaryField(String fieldName,
                        byte[] data)
                                throws IOException

Convenience method for outputting a field entry ("member") that contains specified data in base64-encoded form. Equivalent to:

      writeFieldName(fieldName);
      writeBinary(value);

Throws:
  `IOException`

#### writeArrayFieldStart

    public final void writeArrayFieldStart(String fieldName)
                                    throws IOException

Convenience method for outputting a field entry ("member") (that will contain a JSON Array value), and the START_ARRAY marker. Equivalent to:

      writeFieldName(fieldName);
      writeStartArray();

Note: caller still has to take care to close the array (by calling {#link #writeEndArray}) after writing all values of the value Array.

Throws:
  `IOException`

#### writeObjectFieldStart

    public final void writeObjectFieldStart(String fieldName)
                                     throws IOException

Convenience method for outputting a field entry ("member") (that will contain a JSON Object value), and the START_OBJECT marker. Equivalent to:

      writeFieldName(fieldName);
      writeStartObject();

Note: caller still has to take care to close the Object (by calling {#link #writeEndObject}) after writing all entries of the value Object.

Throws:
  `IOException`

#### writeObjectField

    public final void writeObjectField(String fieldName,
                        Object pojo)
                                throws IOException

Convenience method for outputting a field entry ("member") that has contents of specific Java object as its value. Equivalent to:

      writeFieldName(fieldName);
      writeObject(pojo);

Throws:
  `IOException`

#### writeOmittedField

    public void writeOmittedField(String fieldName)
                           throws IOException

Method called to indicate that a property in this position was skipped. It is usually only called for generators that return `false` from `canOmitFields()`.

Default implementation does nothing.

Throws:
  `IOException`
Since:
  2.3

#### copyCurrentEvent

    public void copyCurrentEvent(JsonParser p)
                          throws IOException

Method for copying contents of the current event that the given parser instance points to. Note that the method will not copy any other events, such as events contained within JSON Array or Object structures.

Calling this method will not advance the given parser, although it may cause parser to internally process more data (if it lazy loads contents of value events, for example)

Throws:
  `IOException`

#### copyCurrentStructure

    public void copyCurrentStructure(JsonParser p)
                              throws IOException

Method for copying contents of the current event and following events that it encloses the given parser instance points to.

So what constitutes enclosing? Here is the list of events that have associated enclosed events that will get copied:

- `JsonToken.START_OBJECT`: all events up to and including matching (closing) `JsonToken.END_OBJECT` will be copied
- `JsonToken.START_ARRAY` all events up to and including matching (closing) `JsonToken.END_ARRAY` will be copied
- `JsonToken.FIELD_NAME` the logical value (which can consist of a single scalar value; or a sequence of related events for structured types (JSON Arrays, Objects)) will be copied along with the name itself. So essentially the whole field entry (name and value) will be copied.

After calling this method, parser will point to the last event that was copied. This will either be the event parser already pointed to (if there were no enclosed events), or the last enclosed event copied.

Throws:
  `IOException`

#### getOutputContext

    public abstract JsonStreamContext getOutputContext()

Returns:
  Context object that can give information about logical position within generated json content.

#### flush

    public abstract void flush()
                        throws IOException

Method called to flush any buffered content to the underlying target (output stream, writer), and to flush the target itself as well.

Specified by:
  `flush` in interface `Flushable`
Throws:
  `IOException`

#### isClosed

    public abstract boolean isClosed()

Method that can be called to determine whether this generator is closed or not. If it is closed, no more output can be done.

#### close

    public abstract void close()
                        throws IOException

Method called to close this generator, so that no more content can be written.

Whether the underlying target (stream, writer) gets closed depends on whether this generator either manages the target (i.e. is the only one with access to the target -- case if caller passes a reference to the resource such as File, but not stream); or has feature `JsonGenerator.Feature.AUTO_CLOSE_TARGET` enabled. If either of above is true, the target is also closed. Otherwise (not managing, feature not enabled), target is not closed.

Specified by:
  `close` in interface `Closeable`
Specified by:
  `close` in interface `AutoCloseable`
Throws:
  `IOException`

#### _reportError

    protected void _reportError(String msg)
                         throws JsonGenerationException

Helper method used for constructing and throwing `JsonGenerationException` with given base message.

Note that sub-classes may override this method to add more detail or use a `JsonGenerationException` sub-class.

Throws:
  `JsonGenerationException`

#### _throwInternal

    protected final void _throwInternal()

#### _reportUnsupportedOperation

    protected void _reportUnsupportedOperation()

#### _writeSimpleObject

    protected void _writeSimpleObject(Object value)
                               throws IOException

Helper method to try to call appropriate write method for given untyped Object. At this point, no structural conversions should be done, only simple basic types are to be coerced as necessary.

Parameters:
  `value` - Non-null value to write
Throws:
  `IOException`